// data
let file;
let data;

// visualization
let counterData = 0;
let zoom = 10.0;

let wind = [];
let sun = [];
let rain = [];
let temp = [];

let modulator = [];
let modulator2 = [];



// sound design




// preload
function preload() {

  // load json file with weather data

  //file = loadJSON("data/DWD-Augsburg-2009-2019.json"); // >> run on (local) webserver
  file = loadJSON("https://raw.githubusercontent.com/HybridThingsLab/course-interaction-design/master/Block_I/data/DWD-Augsburg-2009-2019.json");

}

// setup
function setup() {

  // canvas
  createCanvas(1280, 800);



  // get all weather data
  data = file.data;

  for(let i = 0; i < data.length; i++) {
    // sound level nr. 1
    let x = 210;
    let v = data[i].FM;
    let p = new SoundLevel(x, v);
    wind.push(p);

    // sound level nr. 2
    let x2 = 430;
    let v2 = data[i].SDK;
    let p2 = new SoundLevel(x2, v2);
    sun.push(p2);

    // sound level nr. 3
    let x3 = 650;
    let v3 = data[i].RSK;
    let p3 = new SoundLevel(x3, v3);
    rain.push(p3);

    //sound level nr. 4
    let x4 = 870;
    let v4 = abs(data[i].TMK);
    let p4 = new SoundLevel(x4, v4);
    temp.push(p4);
  }

  for(let i = 0; i < 4; i++) {
    let modulatorX = 210 + i * 220;
    let modulatorY = height/2+200;
    let modulatorB = 1;
    let modulatorH = 150;
    let mod = new Modulator(modulatorX, modulatorY, modulatorB, modulatorH);
    modulator.push(mod);

    let modulatorX2 = 210 + i * 220;
    let modulatorY2 = height/2+200;
    let modulatorB2 = 20;
    let modulatorH2 = 40;
    let mod2 = new Modulator(modulatorX2, modulatorY2, modulatorB2, modulatorH2);
    modulator2.push(mod2);
  }



}

// draw
function draw() {

  // clear background
  background(0);

  // show current date
  fill(255);
  noStroke();
  textAlign(LEFT);
  text(data[counterData].MESS_DATUM, 8, 16);

 

  wind[counterData].show();
  sun[counterData].show();
  rain[counterData].show();
  temp[counterData].show();

  for(let i = 0; i < modulator.length; i++) {
    modulator[i].show();
    modulator2[i].show();
    
  }

  // show wind speed
  /*let wind = data[counterData].FM;
  fill(255);
  noStroke();
  rect(210, height / 2, 20, -wind * zoom);*/
  textAlign(RIGHT);
  fill(255);
  text(data[counterData].FM + " m/s", 210 + 28, height / 2 + 30); 

  /*// show hours of sunshine
  let sun = data[counterData].SDK;
  rect(430, height / 2, 20, -sun *zoom); */
  text(data[counterData].SDK + ' h/d', 430 + 28, height / 2 + 30);

  /*// show rainfall
  let rain = data[counterData].RSK;
  rect(650, height / 2, 20, -rain * zoom); */
  text(data[counterData].RSK + ' mm', 650 + 28, height / 2 + 30);

  /*// show temperature
  let temp = data[counterData].TMK;
  rect(870, height/2, 20, -abs(temp) * zoom);*/
  text(data[counterData].TMK + ' °C', 870 + 28, height / 2 + 30);

  /*// show snowfall
  let snow = data[counterData].SHK_TAG;
  rect(870, height/2, 20, -snow * zoom);
  text(snow + ' mm', 870 + 28, height / 2 + 24)*/

  // buttons
  

  // counter data
  // just every x frames
  if ((frameCount % 4) == 0) {
    counterData++;
  }
  if (counterData >= data.length) {
    counterData = 0;
  }

  

}

function mouseDragged() {
  for(let i = 0; i < modulator2.length; i++) {
    modulator2[i].drag(pmouseX, pmouseY);
  }
}

function mouseMoved() {
  for(let i = 0; i < modulator2.length; i++) {
    modulator2[i].hover(pmouseX, pmouseY);
  }
}


class SoundLevel {
  constructor(x, v) {
    this.x = x;
    this.value = v;
  }

  show() {
    noStroke();
    fill(60, 170, 140);
    for(let i = 0; i < round(this.value); i++) {
      let y = height/2-i*8;
      rect(this.x, y, 25, 8);

      if(y <= height/2-60) {
        fill(255, 220, 100);
      } 
      if(y <= height/2-100) {
        fill(255, 80, 0);
      }
      if(y <= height/2-120){
        fill(200, 60, 0);
      }
      
    }
    
  }


  makeSound() {

  }
}

class Modulator {
  constructor(x, y, b, h) {
    this.x = x;
    this.y = y;
    this.b = b;
    this.h = h;
    this.value = 190;
    
  }

  show() {
    noStroke();
    fill(this.value);
    rectMode(CENTER);
    rect(this.x, this.y, this.b, this.h);
  }

  drag(xpos, ypos) {
    let d = dist(xpos, ypos, this.x, this.y);
    if(d < this.h/2) {
      this.y = ypos;
      if(this.y < height/2+200-75+this.h/2) {
        this.y = height/2+200-75+this.h/2;
      } else if(this.y > height/2+200+75-this.h/2) {
        this.y = height/2+200+75-this.h/2;
      }
    }

  }

  hover(xpos, ypos) {
    let d = dist(xpos, ypos, this.x, this.y);
    if(d < this.h/2) {
      this.value = 255;
    } else {
      this.value = 190;
    }
  }
}