// data
let file;
let data;
let year = 2009;

// visualization
let counterX = 0;
let zoom = 5.0;

let nav = [];
let x1 = 950;


// preload
function preload() {

  // load json file with weather data

  //file = loadJSON("data/DWD-Augsburg-2009-2019.json"); // >> run on (local) webserver
  file = loadJSON("https://raw.githubusercontent.com/HybridThingsLab/course-interaction-design/master/Block_I/data/DWD-Augsburg-2009-2019.json");

}

// setup
function setup() {

  // canvas
  createCanvas(1280, 800);
  
  // get weather data
  data = file.data;


  for(let i = 0; i < 10; i++) {
    let x = i*31.5+950;
    let y = height - 100;
    let s = 50;
    let n = new ScrollNavigation(x, y, s);
    nav.push(n);
  }

  

}



// draw
function draw() {

  // clear background
  background(0);

  // draw selector
  rectMode(CENTER);
  fill(255);
  rect(x1, 700, 3, 80);

  // draw line
  stroke(255);
  strokeWeight(1);
  noFill();
  line(0, height / 2, width, height / 2);

  // variable to draw text year just once in for-loop
  let drawOneTime = true;

  // loop through weather data
  for (let i = 0; i < data.length; i++) {

    // get current year
    let currentYear = data[i].MESS_DATUM.substr(0, 4);
    // check if specific year, for example '2018'
    if (currentYear == year) {

      // year as text one time
      if (drawOneTime == true) {
        fill(255);
        noStroke();
        textSize(40);
        text(currentYear, 25, 50);
        drawOneTime = false;
      }

      // GET VALUE(S) OF WEATHER DATA HERE!
      // for example get average temperature of each day (see JSON file for further data)
      let temperature = data[i].TMK;

      // draw here (WHERE THE MAGIC HAPPENS!)
      stroke(255);
      strokeWeight(width / 365);
      noFill();
      line(counterX, height / 2, counterX, height / 2 - temperature * zoom);

      // counter x position
      counterX += width / 365;

    }

  }
  counterX = 0;

 

  for(let i = 0; i < nav.length; i++) {
    nav[i].show();
  }

  
  
  


}

function mouseWheel(event) {
  if(event.delta > 0) {
    x1 += 31.5;
    year++;
    if(x1 > 1233.5) {
      x1 = 950;
      year = 2009;
    }
  } else if(event.delta < 0) {
    x1 -= 31.5;
    year--;
    if(x1 < 950) {
      x1 = 1233.5;
      year = 2018;
    }
  } 
}


class ScrollNavigation {
  constructor(x, y, s) {
    this.x = x;
    this.y = y;
    this.s = s;
  }

  show() {
    noStroke();
    fill(255);
    rectMode(CENTER);
    rect(this.x, this.y, 2, this.s);
  }
}