let rects = [];
let amount = 10;

function setup() {
  createCanvas(600, 600);

    for(let i = 0; i < amount; i++) {
      let x = random(100, width-100);
      let y = random(100, height-100);
      let b = random(30, 100);
      let r = new Rectangle(x, y, b);
      rects.push(r);
    }
}

function mouseDragged() {
  for(let i = 0; i < rects.length; i++) {
    rects[i].drag(mouseX, mouseY);
  }
}

function mouseMoved() {  
  for(let i = 0; i < rects.length; i++) {
    rects[i].hover(mouseX, mouseY);
  }
}

function draw() {
  background(0);
  for(let i = 0; i < rects.length; i++) {
    rects[i].show();
    rects[i].tickle(mouseX, mouseY);
  }
}

class Rectangle {
  constructor(x, y, b) {
  this.x = x;
  this.y = y;
  this.b = b;
  this.value = 0;
  }

  tickle(xpos, ypos) {
    let d = dist(xpos, ypos, this.x, this.y);
    if(d < this.b/2) {
    this.x = this.x + random(-5, 5);
    this.y = this.y + random(-5, 5);
    }
  }

  show() {
    stroke(255);
    strokeWeight(2);
    fill(this.value, 100);
    rectMode(CENTER);
    rect(this.x, this.y, this.b, this.b);
  }

  hover(xpos, ypos) {
    let d = dist(xpos, ypos, this.x, this.y);
    if(d < this.b/2) {
      this.value = 255;
    } else {
      this.value = 0;
    }

  }

  drag(xpos, ypos) {
    let d = dist(xpos, ypos, this.x, this.y);
    if(d < this.b/2) {
      this.x = xpos;
      this.y = ypos;
    }
  }

}